<?PHP
/*
	Gateway.class.php
		Release:			1.0
		Release Date: 02/27/06
		Author:				Jay Kramer
		Company:			Control Vision Corp.
		License:			GPL

		Feel free to distribute this code.  This example includes and uses the third
		party XML client available  from http://www.active-link.com/software/
*/

define ("USETESTACCOUNT", true);
define ("GW_CLIENTID", "1035");
define ("GW_SITEID", "655877458");
define ("GW_PRICEID", "77");
define ("GW_KEY", "SVD-491-QMFQ-WU89");
define ("GW_PASSORD", "234980");


require_once("XML/classes/include.php");
import("org.active-link.xml.XML");
import("org.active-link.xml.XMLDocument");

class CreditCardTransactionException extends Exception {

  /* Redefine the exception so message isn't optional */
  public function __construct($message, $code = 0) {

    /* make sure everything is assigned properly */
    parent::__construct($message, $code);
  }

  /* custom string representation of object */
  public function __toString() {
    return "Error [{$this->code}]: {$this->message}.\n";
  }

  public function __toHtml() {
    return "<font color=\"red\"><b>Error </b>[{$this->code}]: {$this->message}.</font><br />";
  }
}

class CreditCardTransaction {
	private $clientid 					= '';	// required
	private $siteid   					= '';	// required
	private $priceid  					= '';	// required
	private $password 					= '';	// required
	private $ver      					= '';
	private $product  					= '';
	private $key   							= '';	// required
	private $transtype 					= '';	// required
	private $cardnumber 				= '';	// required
	private $expmonth   				= '';	// required
	private $expyear    				= '';	// required
	private $amount   					= '';	// required
	private $gateid							= '';
	private $first_name 				= '';	// required (ecommerce)
	private $last_name  				= '';	// required (ecommerce)
	private $address   					= '';	// required (ecommerce)
	private $city   						= '';	// required (ecommerce)
	private $state  						= '';	// required (ecommerce)
	private $zip   							= '';	// required (ecommerce)
	private $country   					= '';	// required (ecommerce)
	private $phone   						= '';	// required (ecommerce)
	private $email   						= '';	// required (ecommerce)
	private $CVV2								= '';
	private $clientip						= '';
	private $trackdata					= '';
	private $cardpresent 				= 'no';
	private $quasicash 					= '';
	private $readerpresent 			= 'no';
	private $client_transref 		= '';
	private $authcode						= '';
	private $allow_duplicates		= 'no';
	private $corporatecard 			= '';
	private $recurring 					= 'no';
	private $installmentcount 	= 0;
	private $installmentseqno 	= 0;
	private $username 					= '';
	private $egoodsindicator 		= ''; // "P" for physical goods, "D" for digital goods, or "PD" for a combination of both;
	private $RequestXML;
	private $ResponseXML;

// default constructor.  Can initialize First Name, Last Name, Address, City, State, Zip, Country, Phone, and Email.  Call with parameters for what you wish to initialize.
	public function __construct()
	{
// test account information...
		if (USETESTACCOUNT === true)
		{
			echo 'Debugging enabled';
			$this->clientid = "1035";
			$this->siteid 	= "655877458";
			$this->priceid  = "77";
			$this->key			= "SVD-491-QMFQ-WU89";
			$this->password = "234980";
			$this->setTransType("SALE");  // default to a SALE
		} else {
// actual account information...
			$this->clientid = GW_CLIENTID;
			$this->siteid 	= GW_SITEID;
			$this->priceid  = GW_PRICEID;
			$this->key			= GW_KEY;
			$this->password = GW_PASSWORD;
			$this->setTransType("SALE");  // default to a SALE
		}
		$args = func_get_args();
		foreach(array("setFirst_Name", "setLast_Name", "setAddress", "setCity", "setState", "setZip", "setCountry", "setPhone", "setEmail") as $setFunc)
		{
			if(empty($args))
			{
			 break;
			}
			$this->$setFunc(array_shift($args));
		}
	}

	public function setClientID($clientid)
	{
		// maxlength: 6
		if (strlen($clientid) <= 6)
		{
		 	$this->clientid = $clientid;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid ClientID", 4303);
			return false;
		}
	}

	public function getClientID()
	{
		return $this->clientid;
	}

	public function setSiteID($siteid)
	{
		// maxlength: 10
		if (strlen($siteid) <= 10)
		{
  		$this->siteid = $siteid;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid SiteID", 4304);
			return false;
		}
	}

	public function getSiteID()
	{
		return $this->siteid;
	}

	public function setPriceID($priceid)
	{
		// maxlength: 6
		if (strlen($priceid) <= 6)
		{
  		$this->priceid = $priceid;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid PriceID", 4305);
			return false;
		}
	}

	public function getPriceID()
	{
		return $this->priceid;
	}

	public function setPassword($password)
	{
		// maxlength: 8
		if (strlen($password) <= 8)
		{
  		$this->password = $password;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Password", 4306);
			return false;
		}
	}

	public function getPassword()
	{
		return $this->password;
	}

	public function setVer($ver)
	{
		// maxlength: 16
		if (strlen($ver) <= 16)
		{
  		$this->ver = $ver;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Ver", 4307);
			return false;
		}
	}

	public function getVer()
	{
		return $this->ver;
	}

	public function setProduct($product)
	{
		// maxlength: 32
		if (strlen($product) <= 32)
		{
  		$this->product = $product;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Product", 4308);
			return false;
		}
	}

	public function getProduct()
	{
		return $this->product;
	}

	public function setKey($key)
	{
		// maxlength: 20
		if (strlen($key) <= 20)
		{
  		$this->key = $key;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Key", 4309);
			return false;
		}
	}

	public function getKey()
	{
		return $this->key;
	}

	public function setTransType($transtype)
	{
		$validcodes = array('ACTIVATE','ADD','AUTH','BALANCE','CHECKVER','CREDIT','DEACTIVATE','FORCE','INCREMENTAL','OFFLINE','OFFLINEAUTH','OFFLINEFORCE','REDEM','REPLACE','REVERSAL','SALE','TIPEDIT','UPDATE','VOID');
		if (in_array($transtype, $validcodes))
		{
			// maxlength: 18
			if (strlen($transtype) <= 18)
			{
				$this->transtype = $transtype;
				return true;
			} else {
			  throw new CreditCardTransactionException("unknown TransType failure", 4302);
				return false;
			}
		} else {
		  throw new CreditCardTransactionException("invalid TransType specified", 4301);
		}
	}

	public function getTransType()
	{
		return $this->transtype;
	}

	public function setCardNumber($cardnumber)
	{
		// maxlength: 20
		if (strlen($cardnumber) <= 20)
		{
  		$this->cardnumber = $cardnumber;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid CardNumber", 4310);
			return false;
		}
	}

	public function getCardNumber()
	{
		return $this->cardnumber;
	}

	public function setExpMonth($expmonth)
	{
		// maxlength: 2
		if ((strlen($expmonth) <= 2) and (($expmonth >= 1) and (expmonth <= 12)))
		{
			$this->expmonth = $expmonth;
			return true;
		} else {
		  throw new CreditCardTransactionException("Invalid ExpMonth", 4311);
			return false;
		}
	}

	public function getExpMonth()
	{
		return $this->expmonth;
	}

	public function setExpYear($expyear)
	{
		// maxlength: 4
		if (strlen($expyear) <= 4)
		{
  		$this->expyear = $expyear;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid ExpYear", 4312);
			return false;
		}
	}

	public function getExpYear()
	{
		return $this->expyear;
	}

	public function setAmount($amount)
	{
		// maxlength: 12
		if (strlen($amount) <= 12)
		{
  		$this->amount = $amount;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Amount", 4313);
			return false;
		}
	}

	public function getAmount()
	{
		return $this->amount;
	}

	public function setGateID($gateid)
	{
		// maxlength: 12
		if (strlen($gateid) <= 12)
		{
  		$this->gateid = $gateid;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid GateID", 4314);
			return false;
		}
	}

	public function getGateID()
	{
		return $this->gateid;
	}

	public function setFirst_Name($first_name)
	{
		// maxlength: 20
		if (strlen($first_name) <= 20)
		{
  		$this->first_name = $first_name;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid First_Name", 4315);
			return false;
		}
	}

	public function getFirst_Name()
	{
		return $this->first_name;
	}

	public function setLast_Name($last_name)
	{
		// maxlength: 20
		if (strlen($last_name) <= 20)
		{
  		$this->last_name = $last_name;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Last_Name", 4316);
			return false;
		}
	}

	public function getLast_Name()
	{
		return $this->last_name;
	}

	public function setAddress($address)
	{
		// maxlength: 30
		if (strlen($address) <= 30)
		{
  		$this->address = $address;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Address", 4317);
			return false;
		}
	}

	public function getAddress()
	{
		return $this->address;
	}

	public function setCity($city)
	{
		// maxlength: 20
		if (strlen($city) <= 20)
		{
  		$this->city = $city;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid City", 4318);
			return false;
		}
	}

	public function getCity()
	{
		return $this->city;
	}

	public function setState($state)
	{
		// maxlength: 20
		if (strlen($state) <= 20)
		{
  		$this->state = $state;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid State", 4319);
			return false;
		}
	}

	public function getState()
	{
		return $this->state;
	}

	public function setZip($zip)
	{
		// maxlength: 10
		if (strlen($zip) <= 10)
		{
  		$this->zip = $zip;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Zip", 4320);
			return false;
		}
	}

	public function getZip()
	{
		return $this->zip;
	}

	public function setCountry($country)
	{
		// maxlength: 30
		if (strlen($country) <= 30)
		{
  		$this->country = $country;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Country", 4321);
			return false;
		}
	}

	public function getCountry()
	{
		return $this->country;
	}

	public function setPhone($phone)
	{
		// maxlength: 20
		if (strlen($phone) <= 20)
		{
  		$this->phone = $phone;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Phone", 4322);
			return false;
		}
	}

	public function getPhone()
	{
		return $this->phone;
	}

	public function setEmail($email)
	{
		// maxlength: 40
		if (strlen($email) <= 40)
		{
  		$this->email = $email;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Email", 4323);
			return false;
		}
	}

	public function getEmail()
	{
		return $this->email;
	}

	public function setCVV2($CVV2)
	{
		// maxlength: 4
		if (strlen($CVV2) <= 4)
		{
  		$this->CVV2 = $CVV2;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid CVV2", 4324);
			return false;
		}
	}

	public function getCVV2()
	{
		return $this->CVV2;
	}

	public function setClientIP($clientip)
	{
		// maxlength: 20
		if (strlen($clientip) <= 20)
		{
  		$this->clientip = $clientip;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid ClientIP", 4325);
			return false;
		}
	}

	public function getClientIP()
	{
		return $this->clientip;
	}

	public function setTrackData($trackdata)
	{
		// maxlength: (unknown)
		if (strlen($clientid) <= 4096)  // allow up to 4kb.. temp workaround..
		{
  		$this->trackdata = $trackdata;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid TrackData", 4326);
			return false;
		}
	}

	public function getTrackData()
	{
		return $this->trackdata;
	}

	public function setCardPresent($cardpresent)
	{
		if ($cardpresent)
		{
			$this->cardpresent = 'yes';
		} else {
		  $this->cardpresent = 'no';
		}
	}

	public function getCardPresent()
	{
		if ($this->cardpresent == 'yes')
		{
			return true;
		} else {
		  return false;
		}
	}

	public function setQuasiCash($quasicash)
	{
		if ($quasicash)
		{
			$this->quasicash = 'yes';
		} else {
		  $this->quasicash = 'no';
		}
	}

	public function getQuasiCash()
	{
		if ($this->quasicash == 'yes')
		{
			return true;
		} else {
		  return false;
		}
	}

	public function setReaderPresent($readerpresent)
	{
		if ($readerpresent)
		{
			$this->readerpresent = 'yes';
		} else {
		  $this->readerpresent = 'no';
		}
	}

	public function getReaderPresent()
	{
		if ($this->readerpresent == 'yes')
		{
			return true;
		} else {
		  return false;
		}
	}

	public function setClient_TransRef($client_transref)
	{
		// maxlength: 20
		if (strlen($client_transref) <= 20)
		{
  		$this->client_transref = $client_transref;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Client_TransRef", 4327);
			return false;
		}
	}

	public function getClient_TransRef()
	{
		return $this->client_transref;
	}

	public function setAuthCode($authcode)
	{
		// maxlength: 6
		if (strlen($authcode) <= 6)
		{
  		$this->authcode = $authcode;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid AuthCode", 4328);
			return false;
		}
	}

	public function getAuthCode()
	{
		return $this->authcode;
	}

	public function setAllow_Duplicates($allow_duplicates)
	{
		if ($allow_duplicates)
		{
			$this->allow_duplicates = 'yes';
		} else {
		  $this->allow_duplicates = 'no';
		}
	}

	public function getAllow_Duplicates()
	{
		if ($this->allow_duplicates == 'yes')
		{
			return true;
		} else {
		  return false;
		}
	}

	public function setCorporateCard($corporatecard)
	{
		if ($corporatecard)
		{
			$this->corporatecard = 'yes';
		} else {
		  $this->corporatecard = 'no';
		}
	}

	public function getCorporateCard()
	{
		if ($this->corporatecard == 'yes')
		{
			return true;
		} else {
		  return false;
		}
	}

	public function setRecurring($recurring)
	{
		if ($recurring)
		{
			$this->recurring = 'yes';
		} else {
		  $this->recurring = 'no';
		}
	}

	public function getRecurring()
	{
		if ($this->recurring == 'yes')
		{
			return true;
		} else {
		  return false;
		}
	}

	public function setInstallmentCount($installmentcount)
	{
		// maxlength: 8
		if (strlen($installmentcount) <= 8)
		{
  		$this->installmentcount = $installmentcount;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid InstallmentCount", 4329);
			return false;
		}
	}

	public function getInstallmentCount()
	{
		return $this->installmentcount;
	}

	public function setInstallmentSeqNo($installmentseqno)
	{
		// maxlength: 8
		if (strlen($installmentseqno) <= 8)
		{
  		$this->installmentseqno = $installmentseqno;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid InstallmentSeqNo", 4330);
			return false;
		}
	}

	public function getInstallmentSeqNo()
	{
		return $this->installmentseqno;
	}

	public function setUsername($username)
	{
		// maxlength: 20
		if (strlen($username) <= 20)
		{
  		$this->username = $username;
		 	return true;
		} else {
		  throw new CreditCardTransactionException("Invalid Username", 4331);
			return false;
		}
	}

	public function getUsername()
	{
		return $this->username;
	}

	public function setDigitalGoods($digitalgoods)
	{
		if ($digitalgoods)
		{
			if (strpos($this->egoodsindicator, 'P') === false )
			{
				$this->egoodsindicator = 'D';
			} else {
				$this->egoodsindicator = 'PD';
			}
		} else {
			if (strpos($this->egoodsindicator, 'P') === false )
			{
				$this->egoodsindicator = '';
			} else {
				$this->egoodsindicator = 'P';
			}
		}
	}

	public function getDigitalGoods()
	{
		if (strpos($this->egoodsindicator, 'D') === false )
		{
			return false;
		} else {
		  return true;
		}
	}

	public function setPhysicalGoods($physicalgoods)
	{
		if ($physicalgoods)
		{
			if (strpos($this->egoodsindicator, 'D') === false )
			{
				$this->egoodsindicator = 'P';
			} else {
				$this->egoodsindicator = 'PD';
			}
		} else {
			if (strpos($this->egoodsindicator, 'D') === false )
			{
				$this->egoodsindicator = '';
			} else {
				$this->egoodsindicator = 'D';
			}
		}
	}

	public function getPhysicalGoods()
	{
		if (strpos($this->egoodsindicator, 'P') === false )
		{
			return false;
		} else {
		  return true;
		}
	}

	public function prepare_request($urlencode = TRUE)
	{
		$Root_Tag = "request";
		$this->RequestXML = new XML($Root_Tag);

		if (empty($this->clientid))
		{
	  	throw new CreditCardTransactionException('clientid cannot be empty', 4101);
		}
		if (empty($this->siteid))
		{
		  throw new CreditCardTransactionException('siteid cannot be empty', 4102);
		}
		if (empty($this->priceid))
		{
		  throw new CreditCardTransactionException('priceid cannot be empty', 4103);
		}
		if (empty($this->password))
		{
		  throw new CreditCardTransactionException('password cannot be empty', 4104);
		}
		if (empty($this->key))
		{
			throw new CreditCardTransactionException('key cannot be empty', 4105);
		}
		if (!empty($this->transtype))
		{
			$this->RequestXML->setTagContent($this->transtype, $Root_Tag.'/transtype');
		} else {
		  throw new CreditCardTransactionException('transtype cannot be empty', 4106);
		}
		if (!empty($this->cardnumber))
		{
			$this->RequestXML->setTagContent($this->cardnumber, $Root_Tag.'/cardnumber');
		} else {
		  throw new CreditCardTransactionException('cardnumber cannot be empty', 4107);
		}
		if (!empty($this->expmonth))
		{
			$this->RequestXML->setTagContent($this->expmonth, $Root_Tag.'/expmonth');
		} else {
		  throw new CreditCardTransactionException('expmonth cannot be empty', 4108);
		}
		if (!empty($this->expyear))
		{
			$this->RequestXML->setTagContent($this->expyear, $Root_Tag.'/expyear');
		} else {
		  throw new CreditCardTransactionException('expyear cannot be empty', 4109);
		}
		if (!empty($this->amount))
		{
			$this->RequestXML->setTagContent($this->amount, $Root_Tag.'/amount');
		} else {
		  throw new CreditCardTransactionException('amount cannot be empty', 4110);
		}
		if (!empty($this->gateid))
		{
			$this->RequestXML->setTagContent($this->gateid, $Root_Tag.'/gateid');
		}
		if (!empty($this->first_name))
		{
			$this->RequestXML->setTagContent($this->first_name, $Root_Tag.'/first_name');
		} else {
		  throw new CreditCardTransactionException('first_name cannot be empty', 4111);
		}
		if (!empty($this->last_name))
		{
			$this->RequestXML->setTagContent($this->last_name, $Root_Tag.'/last_name');
		} else {
		  throw new CreditCardTransactionException('last_name cannot be empty', 4112);
		}
		if (!empty($this->address))
		{
			$this->RequestXML->setTagContent($this->address, $Root_Tag.'/address');
		} else {
		  throw new CreditCardTransactionException('address cannot be empty', 4113);
		}
		if (!empty($this->city))
		{
			$this->RequestXML->setTagContent($this->city, $Root_Tag.'/city');
		} else {
		  throw new CreditCardTransactionException('city cannot be empty', 4114);
		}
		if (!empty($this->state))
		{
			$this->RequestXML->setTagContent($this->state, $Root_Tag.'/state');
		} else {
		  throw new CreditCardTransactionException('state cannot be empty', 4115);
		}
		if (!empty($this->zip))
		{
			$this->RequestXML->setTagContent($this->zip, $Root_Tag.'/zip');
		} else {
		  throw new CreditCardTransactionException('zip cannot be empty', 4116);
		}
		if (!empty($this->country))
		{
			$this->RequestXML->setTagContent($this->country, $Root_Tag.'/country');
		} else {
		  throw new CreditCardTransactionException('country cannot be empty', 4117);
		}
		if (!empty($this->phone))
		{
			$this->RequestXML->setTagContent($this->phone, $Root_Tag.'/phone');
		} else {
		  throw new CreditCardTransactionException('phone cannot be empty', 4118);
		}
		if (!empty($this->email))
		{
			$this->RequestXML->setTagContent($this->email, $Root_Tag.'/email');
		} else {
		  throw new CreditCardTransactionException('email cannot be empty', 4119);
		}
		if (!empty($this->CVV2))
		{
			$this->RequestXML->setTagContent($this->CVV2, $Root_Tag.'/CVV2');
		}
		if (!empty($this->clientip))
		{
			$this->RequestXML->setTagContent($this->clientip, $Root_Tag.'/clientip');
		}
		if (!empty($this->trackdata))
		{
			$this->RequestXML->setTagContent($this->trackdata, $Root_Tag.'/trackdata');
		}
		if (!empty($this->cardpresent))
		{
			$this->RequestXML->setTagContent($this->cardpresent, $Root_Tag.'/cardpresent');
		}
		if (!empty($this->quasicash))
		{
			$this->RequestXML->setTagContent($this->quasicash, $Root_Tag.'/quasicash');
		}
		if (!empty($this->readerpresent))
		{
			$this->RequestXML->setTagContent($this->readerpresent, $Root_Tag.'/readerpresent');
		}
		if (!empty($this->client_transref))
		{
			$this->RequestXML->setTagContent($this->client_transref, $Root_Tag.'/client_transref');
		}
		if (!empty($this->authcode))
		{
			$this->RequestXML->setTagContent($this->authcode, $Root_Tag.'/authcode');
		}
		if (!empty($this->allow_duplicates))
		{
			$this->RequestXML->setTagContent($this->allow_duplicates, $Root_Tag.'/allow_duplicates');
		}
		if (!empty($this->corporatecard))
		{
			$this->RequestXML->setTagContent($this->corporatecard, $Root_Tag.'/corporatecard');
		}
		if (!empty($this->recurring))
		{
			$this->RequestXML->setTagContent($this->recurring, $Root_Tag.'/recurring');
		}
		if (!empty($this->installmentcount))
		{
			$this->RequestXML->setTagContent($this->installmentcount, $Root_Tag.'/installmentcount');
		}
		if (!empty($this->installmentseqno))
		{
			$this->RequestXML->setTagContent($this->installmentseqno, $Root_Tag.'/installmentseqno');
		}
		if (!empty($this->username))
		{
			$this->RequestXML->setTagContent($this->username, $Root_Tag.'/username');
		}
		if (!empty($this->egoodsindicator))
		{
			$this->RequestXML->setTagContent($this->egoodsindicator, $Root_Tag.'/egoodsindicator');
		}

		$xml = $this->RequestXML->getXMLString();

		if ($urlencode)
		{
			return urlencode($xml);
		} else {
		 	return $xml;
		}
	}

	public function post_request()
	{
// automatic IP logging...
		if (((!empty($_SERVER['REMOTE_ADDR'])) or (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))) and (empty($this->ClientIP)))
		{
			if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
			{
				$this->setClientIP($_SERVER['HTTP_X_FORWARDED_FOR']);
			} else {
				$this->setClientIP($_SERVER['REMOTE_ADDR']);
			}
		}

		$ch = curl_init('https://stats.slimcd.com/wswebservices/transact.asmx/PostXML');
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_HEADER, 0);
       		curl_setopt ($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);
		curl_setopt($ch, CURLOPT_POST, 1);

		$post = "clientid=".urlencode($this->clientid);
		$post .= "&siteid=".urlencode($this->siteid);
		$post .= "&priceid=".urlencode($this->priceid);
		$post .= "&password=".urlencode($this->password);
		$post .= "&ver=".urlencode($this->ver);
		$post .= "&product=".urlencode($this->product);
		$post .= "&key=".urlencode($this->key);
		$post .= "&XMLData=".$this->prepare_request(true);

		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);

		if ($_SERVER['HTTPS'] == 'on')
		{
			curl_setopt($ch, CURLOPT_REFERER, "https://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']);
		} else {
			curl_setopt($ch, CURLOPT_REFERER, "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']);
		}
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$data = curl_exec($ch);
		if (curl_errno($creq)) {
		  throw new CreditCardTransactionException("Error processing request: ".curl_error($creq), 4200);
			return false;
		} else {
	 	  curl_close($creq);
		}

		$this->ResponseXML = new XML($data);

		$this->gateid = $this->ResponseXML->getTagContent("reply/datablock/gateid");
		if ($this->ResponseXML->getTagContent("reply/responsecode") == 0)
		{
			return true;
		} else {
		  throw new CreditCardTransactionException($this->ResponseXML->getTagContent("reply/description"), 4201);
			return false;
		}
	}

}

?>