<?PHP
require_once("Gateway.class.php");

/*
	gatewayexample.php
		Release:			1.0
		Release Date: 02/27/06
		Author:				Jay Kramer
		Company:			Control Vision Corp.
		License:			GPL

		This is a quick and dirty example of how to utilize the gateway class and get responses.

		Feel free to modify this code to suit your needs.  Provided as an example.

		Feel free to distribute this code.  This example includes and uses the third
		party XML client available  from http://www.active-link.com/software/
*/


try {

	$trans = New CreditCardTransaction("Joe", "Nobody");

	// Uncomment to override defaults set in gateway.class.php
	//$trans->setClientID("cltid");
	//$trans->setSiteID("siteid");
	//$trans->setPriceID("1");
	//$trans->setPassword("Password");
	//$trans->setKey("key");

	$trans->setAddress("123 Mockingbird Lane");
	$trans->setCity("Levittown");
	$trans->setState("PA");
	$trans->setZip("19055");
	$trans->setCountry("US");
	$trans->setPhone("610-945-1234");
	$trans->setEmail("test@example.com");
	$trans->setAllow_Duplicates(true);
	$trans->setAmount("129.95");

	$trans->setDigitalGoods(true);

	$trans->setCardNumber("4111111111111111");
	$trans->setExpMonth("03");
	$trans->setExpYear("06");


	$trans->setVer("0.9");
	$trans->setProduct("My Widget");

} catch (CreditCardTransactionException $e) {
	echo $e->__toHtml();
}

echo "<html><head><title>test</title></head><body>";

try {
	echo "<pre>";
	// optional: call Prepare Request with UrlEncode set to False, to see what is going to be
	//	sent to SlimCD..  prepare also does basic validation of the input..
	echo htmlspecialchars($trans->prepare_request(false));
	echo "</pre>";
} catch (CreditCardTransactionException $e) {
	// an error occured while preparing the request..  validation failed.
	echo $e->__toHtml();
}


try {
	// Post this transaction to SlimCD...
	echo "<br><br><br><br>Posting request";
	if ($trans->post_request())
	{
		echo "<br><br><br><br><b>Thank you! Your transaction completed successfully!</b>";
	}
} catch (CreditCardTransactionException $e) {
	// an error occurred, display it in the output...
	echo $e->__toHtml();
}
echo "</body></html>";

?>